/*
 * @(#) $Id: PageStatementInternalIterator.java 8610 2011-10-27 12:59:40Z laslovd $
 *
 * Copyright 2009/2010 by sIT Solutions,
 * A-1110 Wien, Geiselbergstr.21-25.
 * All rights reserved.
 *
 */
package org.openxma.dsl.generator.impl;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import org.openxma.dsl.pom.model.Statement;

import at.spardat.xma.guidesign.XMAPage;
import at.spardat.xma.guidesign.flex.XMAFunction;

abstract public class PageStatementInternalIterator {
    
    private XMAPage page;
    
    public PageStatementInternalIterator ( XMAPage page ) {
        this.page = page;
    }

    public boolean iterate () {
        for ( Iterator<XMAFunction> it = getFunctions(page).iterator(); it.hasNext(); ) {
            XMAFunction func = it.next();
            boolean res = new FunctionStatementInternalIterator(func,page) {
                                  @Override
                                  protected boolean visit(Statement stmt, XMAPage page) {
                                      return PageStatementInternalIterator.this.visit(stmt);
                                  }
                              }.iterate();
            if ( res )
                return true;
        }
        return false;
    }
    
    /**
     * @return true to continue, false to stop grabbing
     */
    protected abstract boolean visit ( Statement stmt );

    protected Collection<XMAFunction> getFunctions(XMAPage page) {
        Set<XMAFunction> res = new HashSet<XMAFunction>();
        res.addAll(page.getFunctions());
        res.addAll(page.getEnterFunction());
        res.addAll(page.getInitFunction());
        res.addAll(page.getLeaveFunction());
        return res;
    }

}
